<template>
	<v-container>
		<p class="text-center display-1">Estadísticas</p>
		<v-row justify="center" justify-sm="end">
			<v-col cols="12" sm="4">
				<v-select
					outlined
					label="Seleccione un tipo de gráfica"
					v-model="type"
					:items="['Género','Ciudad','Institución','Carrera']"
				/>
			</v-col>
		</v-row>
		<GraphicGender v-if="typeGraphic === 'gender'" :width="400" :height="400" />
		<GraphicCity v-if="typeGraphic === 'city'" :width="400" :height="400" />
		<GraphicInstitute v-if="typeGraphic === 'institute'" :width="400" :height="400" />
		<GraphicCareer v-if="typeGraphic === 'career'" :width="400" :height="400" />
		<Navigation />
	</v-container>
</template>

<script>
import EventBus from "../../bus";
import Navigation from "@/components/Navigation";
import GraphicGender from "@/components/admin/GraphicGender";
import GraphicCity from "@/components/admin/GraphicCity";
import GraphicInstitute from "@/components/admin/GraphicInstitute";
import GraphicCareer from "@/components/admin/GraphicCareer";
import { mapMutations } from "vuex";
import gql from "graphql-tag";

export default {
	name: "Statistics",
	components: {
		Navigation,
		GraphicGender,
		GraphicCity,
		GraphicInstitute,
		GraphicCareer
	},
	data: () => ({
		type: ""
	}),
	watch: {
		type: function(val) {
			this.getData();
		}
	},
	computed: {
		typeGraphic() {
			switch (this.type) {
				case "Género":
					return "gender";
					break;
				case "Ciudad":
					return "city";
					break;
				case "Institución":
					return "institute";
					break;
				case "Carrera":
					return "career";
					break;
			}
		}
	},
	methods: {
		...mapMutations(["saveUserData"]),

		// Obtiene los datos para generar las gráficas
		async getData() {
			try {
				switch (this.type) {
					case "Género":
						const dataGender = await this.$apollo.query({
							query: gql`
								query($param: String!) {
									getDataToGraphics(param: $param) {
										key
										value
									}
								}
							`,
							variables: {
								param: this.typeGraphic
							}
						});
						EventBus.$emit(
							"dataGender",
							dataGender.data.getDataToGraphics
						);
						break;
					case "Ciudad":
						const dataCity = await this.$apollo.query({
							query: gql`
								query($param: String!) {
									getDataToGraphics(param: $param) {
										key
										value
									}
								}
							`,
							variables: {
								param: this.typeGraphic
							}
						});
						EventBus.$emit(
							"dataCity",
							dataCity.data.getDataToGraphics
						);
						break;
					case "Institución":
						const dataInstitute = await this.$apollo.query({
							query: gql`
								query($param: String!) {
									getDataToGraphics(param: $param) {
										key
										value
									}
								}
							`,
							variables: {
								param: this.typeGraphic
							}
						});
						EventBus.$emit(
							"dataInstitute",
							dataInstitute.data.getDataToGraphics
						);
						break;
					case "Carrera":
						const dataCareer = await this.$apollo.query({
							query: gql`
								query($param: String!) {
									getDataToGraphics(param: $param) {
										key
										value
									}
								}
							`,
							variables: {
								param: this.typeGraphic
							}
						});
						EventBus.$emit(
							"dataCareer",
							dataCareer.data.getDataToGraphics
						);
						break;
				}
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
	}
};
</script>